Package: org.codehaus.groovy.macro.methods

## [Java] Class MacroGroovyMethods

- org.codehaus.groovy.macro.methods.MacroGroovyMethods

-     public class MacroGroovyMethods
      extends Object

- - ### Nested Class Summary

    Nested classes
    Modifiers | Name | Description
    --- | --- | ---
    `static class` | `MacroGroovyMethods.MacroValuePlaceholder` |

  - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static String` | `DOLLAR_VALUE` |

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public static ListExpression` | `buildSubstitutions(SourceUnit source, ASTNode expr)`
    `` | `protected static ClosureExpression` | `getClosureArgument(SourceUnit source, MethodCallExpression call)`
    `` | `protected static TupleExpression` | `getMacroArguments(SourceUnit source, MethodCallExpression call)`
    `` | `protected SourceUnit` | `getSourceUnit()`
    `<T>` | `public static T` | `macro(Object self, Closure cl)`
    `` | `public static Expression` | `macro(MacroContext macroContext, ClosureExpression closureExpression)`
    `<T>` | `public static T` | `macro(Object self, boolean asIs, Closure cl)`
    `` | `public static Expression` | `macro(MacroContext macroContext, ConstantExpression asIsConstantExpression, ClosureExpression closureExpression)`
    `<T>` | `public static T` | `macro(Object self, CompilePhase compilePhase, Closure cl)`
    `` | `public static Expression` | `macro(MacroContext macroContext, PropertyExpression phaseExpression, ClosureExpression closureExpression)`
    `<T>` | `public static T` | `macro(Object self, CompilePhase compilePhase, boolean asIs, Closure cl)`
    `` | `public static Expression` | `macro(MacroContext macroContext, PropertyExpression phaseExpression, ConstantExpression asIsConstantExpression, ClosureExpression closureExpression)`
    `` | `public void` | `visitClass(ClassNode node)`
    `` | `public void` | `visitMethodCallExpression(MethodCallExpression call)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Field Detail

    - #### public static final String DOLLAR_VALUE

  - ### Method Detail

    - #### public static ListExpression buildSubstitutions(SourceUnit source, ASTNode expr)

    - #### protected static ClosureExpression getClosureArgument(SourceUnit source, MethodCallExpression call)

    - #### protected static TupleExpression getMacroArguments(SourceUnit source, MethodCallExpression call)

    - #### @Override protected SourceUnit getSourceUnit()

    - #### <T> public static T macro(Object self, @DelegatesTo(MacroValuePlaceholder.class) Closure cl)

    - #### @Macro public static Expression macro(MacroContext macroContext, ClosureExpression closureExpression)

    - #### <T> public static T macro(Object self, boolean asIs, @DelegatesTo(MacroValuePlaceholder.class) Closure cl)

    - #### @Macro public static Expression macro(MacroContext macroContext, ConstantExpression asIsConstantExpression, ClosureExpression closureExpression)

    - #### <T> public static T macro(Object self, CompilePhase compilePhase, @DelegatesTo(MacroValuePlaceholder.class) Closure cl)

    - #### @Macro public static Expression macro(MacroContext macroContext, PropertyExpression phaseExpression, ClosureExpression closureExpression)

    - #### <T> public static T macro(Object self, CompilePhase compilePhase, boolean asIs, @DelegatesTo(MacroValuePlaceholder.class) Closure cl)

    - #### @Macro public static Expression macro(MacroContext macroContext, PropertyExpression phaseExpression, ConstantExpression asIsConstantExpression, ClosureExpression closureExpression)

    - #### @Override public void visitClass(ClassNode node)

    - #### @Override public void visitMethodCallExpression(MethodCallExpression call)